import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor findProfessor(int empId) {
    Query q = em.createQuery("SELECT e FROM Professor e WHERE e.id =  ?1");
    q.setParameter(1, empId);
    try {
      return (Professor) q.getSingleResult();
    } catch (NoResultException e) {
      return null;
    }
  }

  public Professor findProfessorNoCache(int empId) {
    Query q = em.createQuery("SELECT e FROM Professor e WHERE e.id = ?1");
    // force read from database
    q.setHint("cacheUsage", oracle.toplink.essentials.queryframework.ObjectLevelReadQuery.DoNotCheckCache);
    q.setParameter(1, empId);
    try {
      return (Professor) q.getSingleResult();
    } catch (NoResultException e) {
      return null;
    }
  }

  public Professor findProfessorNoCacheNamed(int empId) {
    Query q = em.createNamedQuery("findProfessorNoCache");
    q.setParameter(1, empId);
    try {
      return (Professor) q.getSingleResult();
    } catch (NoResultException e) {
      return null;
    }
  }

  public Collection<Professor> findAllProfessors() {
    return (Collection<Professor>) em.createQuery("SELECT e FROM Professor e").getResultList();
  }

}